package roebling;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class DevFrame extends JFrame {
  JPanel contentPane;
  JDesktopPane jDesktopPane = new JDesktopPane();
  BorderLayout borderLayout1 = new BorderLayout();

  /**Construct the frame*/
  public DevFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      setupCustomCursors();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    g.devFrame = this;
    setUpEditingFrames();
  }
  /**Component initialization*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(DevFrame.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(1400, 1000));
    this.setTitle("Roebling");

    contentPane.add(jDesktopPane, BorderLayout.CENTER);
  }
  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void setupCustomCursors() {
    g.defaultCursor = new Cursor(Cursor.DEFAULT_CURSOR);
    g.textCursor = Toolkit.getDefaultToolkit().createCustomCursor(new ImageIcon("images/textCursor.gif").getImage(),
                                                                  new java.awt.Point(5,12), "TEXT_CURSOR");
    g.pointCursor = Toolkit.getDefaultToolkit().createCustomCursor(new ImageIcon("images/pointCursor.gif").getImage(),
                                                                  new java.awt.Point(8,8), "POINT_CURSOR");
    g.lineCursor = Toolkit.getDefaultToolkit().createCustomCursor(new ImageIcon("images/lineCursor.gif").getImage(),
                                                                  new java.awt.Point(0,0), "LINE_CURSOR");
    g.imageCursor = Toolkit.getDefaultToolkit().createCustomCursor(new ImageIcon("images/imageCursor.gif").getImage(),
                                                                  new java.awt.Point(0,0), "IMAGE_CURSOR");
    g.buttonCursor = Toolkit.getDefaultToolkit().createCustomCursor(new ImageIcon("images/buttonCursor.gif").getImage(),
                                                                  new java.awt.Point(0,0), "BUTTON_CURSOR");
    g.polyCursor = Toolkit.getDefaultToolkit().createCustomCursor(new ImageIcon("images/polyCursor.gif").getImage(),
                                                                  new java.awt.Point(7,12), "POLY_CURSOR");

  }

  void setUpEditingFrames() {
    newResourcesWindow();
//    newFunctionsWindow();
    newSceneGraphWindow();
    newSceneWindow();
  }

  void newResourcesWindow() {
    g.resourcesFrame = new ResourcesFrame();
    g.resourcesFrame.setVisible(true);
    jDesktopPane.add(g.resourcesFrame);
    try {
        g.resourcesFrame.setSelected(true);
    }
    catch (java.beans.PropertyVetoException exception) {
    }
  }

/*  void newFunctionsWindow() {
    g.functionsFrame = new FunctionsFrame();
    g.functionsFrame.setVisible(true);
    jDesktopPane.add(g.functionsFrame);
    try {
      g.functionsFrame.setSelected(true);
    }
    catch (java.beans.PropertyVetoException exception) {
    }
  }*/

  void newSceneGraphWindow() {
    g.sceneGraphPanel = new SceneGraphPanel();
    g.sceneGraphFrame = new SceneGraphFrame();
    g.sceneGraphFrame.setVisible(true);
    jDesktopPane.add(g.sceneGraphFrame);
    try {
        g.sceneGraphFrame.setSelected(true);
    }
    catch (java.beans.PropertyVetoException exception) {
    }
//    g.sceneGraphFrame.getSceneGraphPanel().getEntityNode(sceneManager.getScene()).resized();
  }

  void newSceneWindow() {
    g.scene = new Scene();
    g.sceneFrame = new SceneFrame();
    g.sceneFrame.setVisible(true);
    jDesktopPane.add(g.sceneFrame);
    try {
        g.sceneFrame.setSelected(true);
    }
    catch (java.beans.PropertyVetoException exception) {
    }
  }
}