package roebling;

import javax.swing.JInternalFrame;

/**
 * Title:        PagaGon
 * Description:  ParaGon is a parametric geometry system.
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Simon Greenwold
 * @version 1.0
 */
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class FocusTrackingInternalFrame extends JInternalFrame {
    Component mLastFocus = null;

    public FocusTrackingInternalFrame() {
    }

    public FocusTrackingInternalFrame(String name,
                                      boolean resizeable,
                                      boolean closable,
                                      boolean maximizable,
                                      boolean iconifiable) {
        super(name, resizeable, closable, maximizable, iconifiable);
    }

    public void registerComponents(JPanel panel) {
        Component[] compArray = panel.getComponents();
        for(int i=0; i < panel.getComponentCount(); i++) {
            compArray[i].addFocusListener(new FocusTrackingInternalFrame.ModifiedFocusListener());
        }
    }

    public Component whoHasTheFocus() {
        return mLastFocus;
    }

    class ModifiedFocusListener implements FocusListener {
        public void focusGained(FocusEvent e) {
            Component tempComp = (Component)e.getSource();
            mLastFocus = tempComp;
        }
        public void focusLost(FocusEvent e) { }
    }

}