package roebling;

/**
 * Title:        ParaMour
 * Description:  Parametric design tool.
 * Copyright:    Copyright (c) 2001
 * Company:      NewBricks
 * @author Simon Greenwold
 * @version 1.0
 */

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.plaf.metal.*;

public class GraphNode extends JLayeredPane {

    EnclosureNode mEnclosureNode;
    private static boolean mInitialized;
    protected static boolean mDidDelete;

    protected static Font mButtonFont;

    public GraphNode() {
        super();
        if (!mInitialized)
            initialize();

        mEnclosureNode = null;
        addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
              g.sceneFrame.resetButtons();
              g.sceneFrame.selectArrow();
              g.scenePanel.arrowButtonHit();

                if (g.sceneGraphPanel.getTool() == g.sceneGraphPanel.ERASE_TOOL) {
                    if (canDelete()) {
                        delete();
                        mDidDelete = true;
                        g.sceneGraphPanel.setTool(g.sceneGraphPanel.ARROW_TOOL);
                    }
                }
            }
        });
    }

    private void initialize() {
        mInitialized = true;
        try {
            mButtonFont = MetalLookAndFeel.getSubTextFont();
        }
        catch(Exception e) {    // Doesn't work in applet.
            mButtonFont = null;
        }
    }

    public GraphNode(EnclosureNode enclosureNode) {
        mEnclosureNode = enclosureNode;
    }
/*
    public void setSceneGraph(SceneGraphPanel sceneGraph) {
        mSceneGraph = sceneGraph;
    }

    public SceneGraphPanel getSceneGraph() {
        return mSceneGraph;
    }
*/
    public void setEnclosureNode(EnclosureNode enclosureNode) {
        mEnclosureNode = enclosureNode;
    }

    public EnclosureNode getEnclosureNode() {
        return mEnclosureNode;
    }

    public void delete() {
    }

    protected boolean canDelete() {
        return true;
    }
}