package roebling;

/**
 * Title:        Roebling
 * Description:  Parametric dataflow programming.
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Simon Greenwold
 * @version 1.0
 */
import java.awt.*;
import java.awt.geom.*;
public class GraphicEntity extends Entity {

  public String mEntityType;
  protected int mLayer;
  protected boolean mVisible;
  protected boolean mSelectable;
  protected AffineTransform mSaveTrans;
  protected Point2D mTransHitPoint = new Point2D.Double();

  public GraphicEntity() {
    super();
    mIsInstance = false;
  }

  public boolean isVisible() {
    return mVisible;
  }

  public boolean hit(Point2D hitLocation) {
    return false;
  }

  public int getLayer() {
    return mLayer;
  }
  public void update() {
    int oldLayer = getLayer();
    super.update();
    if (isVisible()) {// && (oldLayer != getLayer())) {
//      g.scene.removeFromDrawList(this);
      g.scene.addToDrawList(this);
    }
  }

  public GraphicEntity(String name, Enclosure enclosure) {
    super(name, enclosure);
  }

  public void setSelected(boolean selected) {
  }

  public void savePreDragLocation() {
  }

  public void move(Point2D mouseDelta) {
  }

  public void setLocation(Point2D location) {
  }

  public void draw(Graphics2D graphics) {
  }

  public void delete() {
    super.delete();
    g.scene.removeFromDrawList(this);
  }

  public boolean isGraphicEntity() {
    return true;
  }

  protected boolean serializeEntity(XMLWriter xmlOut) {
      try {
          xmlOut.startElement("entity");
          Util.serializeElement(xmlOut, "type", mEntityType);
          if (! super.serializeEntity(xmlOut))
              return false;

          xmlOut.endElement("entity");
      }
      catch (Exception e) {
          return false;
      }
      return true;
  }
}