package roebling;

/**
 * Title:        Roebling
 * Description:  Parametric dataflow programming.
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Simon Greenwold
 * @version 1.0
 */

import java.awt.*;
import java.util.*;

public class PropertyType {

  public String mName;
  public Color mColor;
  public int mID;
  public Class mClass;

  public PropertyType() {
  }

  public static int addType(String name, Color color, Class propClass) {
    PropertyType newType = new PropertyType();
    newType.mName = new String(name);
    newType.mColor = new Color(color.getRed(), color.getGreen(), color.getBlue(), color.getAlpha());
    newType.mID = g.propertyTypes.length;
    newType.mClass = propClass;
    g.propertyTypes = (PropertyType[])Util.append(g.propertyTypes, Types.PROPERTY_TYPE, newType);
    return newType.mID;
  }

  public static int addCompoundType(String name, Color color, Vector fieldOrder, HashMap fields, Class propClass) {
    CompoundType newType = new CompoundType();
    newType.mName = new String(name);
    newType.mColor = new Color(color.getRed(), color.getGreen(), color.getBlue(), color.getAlpha());
    newType.mID = g.propertyTypes.length;
    newType.mClass = propClass;
    newType.mFieldOrder = (Vector)fieldOrder.clone();
    newType.mFields = (HashMap)fields.clone();
    g.propertyTypes = (PropertyType[])Util.append(g.propertyTypes, Types.PROPERTY_TYPE, newType);
    return newType.mID;
  }

  // For now we'll be restrictive
  public boolean isCompatable(PropertyType two) {
    return (two.mID == mID);
  }

}