package roebling;

import java.io.File;
import javax.swing.filechooser.*;

/**
 * Title:        Roebling
 * Description:  Parametric dataflow programming.
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Simon Greenwold
 * @version 1.0
 */

public class ResourceFileSystemView extends FileSystemView {

  private static FileSystemView mDefaultView;

  public ResourceFileSystemView() {
  }

  public ResourceFileSystemView(FileSystemView defaultView) {
    mDefaultView = defaultView;
  }

  public File[] getRoots() {
    //return new File[0];// {g.resourceDirectory};
    //return new File[] {new File("C:")};
    return mDefaultView.getRoots();
  }

  public boolean isHiddenFile(File f) {
    return mDefaultView.isHiddenFile(f);
  }
  public boolean isRoot(File f) {
    //return (f.equals(g.resourceDirectory));
    return (f.equals(mDefaultView.getRoots()[0]));
  }
  public File createNewFolder(File containingDir) throws java.io.IOException {
    return mDefaultView.createNewFolder(containingDir);
  }

  public File createFileObject(File dir, String filename) {
    return mDefaultView.createFileObject(dir, filename);
  }

  public File createFileObject(String path) {
    return mDefaultView.createFileObject(path);
  }

  public File[] getFiles(File dir, boolean useFileHiding) {
    return mDefaultView.getFiles(dir, useFileHiding);
  }

  public static FileSystemView getFileSystemView() {
    return mDefaultView.getFileSystemView();
  }

  public File getHomeDirectory() {
    return g.resourceDirectory;
  }

  public File getParentDirectory(File dir) {
    if (dir.equals(g.resourceDirectory)) {
      return g.resourceDirectory;
    }
    else
      return mDefaultView.getParentDirectory(dir);
  }
}