package roebling;

/**
 * Title:        Roebling
 * Description:  Parametric dataflow programming.
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Simon Greenwold
 * @version 1.0
 */
import java.awt.geom.*;

public class Transformation extends Entity {

  public AffineTransform mAffineTrans;
  public String mEntityType;

  public Transformation() {
  }

  public Transformation(String name, Enclosure context) {
    super(name, context);
    mAffineTrans = new AffineTransform();
    context.addTransformation(this);
  }

  public boolean isTransformation() {
    return true;
  }

  public void delete() {
    super.delete();
    mEnclosure.removeTransformation(this);
  }

  protected boolean serializeEntity(XMLWriter xmlOut) {
    try {
      xmlOut.startElement("entity");
      Util.serializeElement(xmlOut, "type", mEntityType);
      if (! super.serializeEntity(xmlOut))
        return false;

      xmlOut.endElement("entity");
    }
    catch (Exception e) {
      return false;
    }
    return true;
  }

}