package roebling;

/**
 * Title:        Roebling
 * Description:  Parametric dataflow programming.
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Simon Greenwold
 * @version 1.0
 */

public class Translation extends Transformation {

  private NumProp mXTransProperty;
  private double mXTrans;
  private NumProp mYTransProperty;
  private double mYTrans;

  public Translation() {
  }

  public Translation(String name, Enclosure context) {
    super(name, context);
    mEntityType = "translation";
    addProperties();
  }

  public void setX(double x) {
    mXTransProperty.value = x;
    mXTransProperty.valueSet();
  }

  public void setY(double y) {
    mYTransProperty.value = y;
    mYTransProperty.valueSet();
  }

  protected void addProperties() {
    mXTransProperty  = new NumProp();
    mXTransProperty.mName = "dX";
    mXTransProperty.value = 0.0;
    addProperty(mXTransProperty);

    mYTransProperty  = new NumProp();
    mYTransProperty.mName = "dY";
    mYTransProperty.value = 0.0;
    addProperty(mYTransProperty);
  }

  protected void readInputs() {
    mXTransProperty.validate();
    mXTrans = mXTransProperty.value;
    mYTransProperty.validate();
    mYTrans = mYTransProperty.value;
  }

  public void run() {
    mAffineTrans.setToTranslation(mXTrans, mYTrans);
  }
}