package roebling;

/**
 * Title:        Roebling
 * Description:  Parametric dataflow programming.
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Simon Greenwold
 * @version 1.0
 */

import java.util.*;
import java.awt.event.*;
import java.io.*;
import java.awt.*;

public class g {

  // Compiler switches // Not any more
  public static boolean HAS_SCENEGRAPH = true;

  public final int NONE = -1;

  // File management
  public static String FS = System.getProperty("file.separator");
  public static String USER_DIR = System.getProperty("user.dir");
  public static String urlBase = "file:" + USER_DIR + FS;
  public static String directoryBase = USER_DIR + FS;
  public static File tempDirectory = new File(directoryBase + "temp");
  public static File sourceDirectory = new File(directoryBase + "source" + FS + "roebling");
  public static File templateDirectory = new File(directoryBase + "templates");
  public static File classDirectory = new File(directoryBase + "classes");
  public static File functionDirectory = new File(directoryBase + "functions");
  public static File resourceDirectory = new File(directoryBase + "resources");

  public static int fileWritingPropertyIDOffset;
  public static int fileWritingEntityIDOffset;
  public static Publisher publisher;

  // Action state
  public static Enclosure activeEnclosure;
  public static Entity selectedEntity;
//  public static boolean hasSceneGraph;

  // Property Type management
  public static PropertyType propertyTypes[] = new PropertyType[0];
    //public static int nextTypeID = 0;
  public static int validateCycle = 0;
  public static int setCycle = 0;



  // Function management
  public static TimerQueue timerQueue = new TimerQueue();
//  public static HashMap functionMap = new HashMap();  // Maps type path to FunctionDirectoryEntry

  // Enclosure management
  public static HashMap enclosureDirectory = new HashMap();

  // Scene graph management
  public static HashMap entityToEntityNode = new HashMap();
  public static PropertyNode[] propertyNodes = new PropertyNode[0];
  public static int nextPropertyNodeID = 0;

  public static Scene scene;
  public static ScenePanel scenePanel;
  public static ScenePanelTransform transform;
  public static SceneGraphPanel sceneGraphPanel;

  public static int nextEntityID = 0;
  public static int nextPropertyID = 0;

  public static SceneFrame sceneFrame;
  public static PlayerFrame playerFrame;
  public static ResourcesFrame resourcesFrame;
  public static SceneGraphFrame sceneGraphFrame;
  public static DevFrame devFrame;

  public static int drawCycle = 0;

  public static double mouseX;
  public static double mouseY;
  public static boolean mouseDown = false;

// Cursor variables
  public static Cursor defaultCursor = null;
  public static Cursor textCursor = null;
  public static Cursor pointCursor = null;
  public static Cursor lineCursor = null;
  public static Cursor imageCursor = null;
  public static Cursor buttonCursor = null;
  public static Cursor polyCursor = null;
  public static Cursor locCursor = null;
  public static Cursor numCursor = null;
  public static Cursor boolCursor = null;
  public static Cursor stringCursor = null;
  public static Cursor colorCursor = null;
  public static Cursor eraseCursor = null;

// Dictionary
//  public static Dictionary dictionary = new Dictionary();

  public g() {
  }

  public static void tr(String string) {
    System.out.println(string);
  }

  public static void initPropertyTypes() {
    Property.NUMBER = PropertyType.addType("Number", Color.red, (new NumProp()).getClass());
    Property.BOOLEAN = PropertyType.addType("Boolean", Color.yellow, (new BoolProp()).getClass());
    Property.STRING = PropertyType.addType("String", Color.green, (new StringProp()).getClass());

    Vector locFieldOrder = new Vector();
    locFieldOrder.add("x");
    locFieldOrder.add("y");
    HashMap locFields = new HashMap();
    locFields.put("x", new Integer(Property.NUMBER));
    locFields.put("y", new Integer(Property.NUMBER));
    Property.LOCATION = PropertyType.addCompoundType("Location", Color.blue, locFieldOrder, locFields, (new LocationProp()).getClass());

    Vector colorFieldOrder = new Vector();
    colorFieldOrder.add("r");
    colorFieldOrder.add("g");
    colorFieldOrder.add("b");
    colorFieldOrder.add("a");
    HashMap colorFields = new HashMap();
    colorFields.put("r", new Integer(Property.NUMBER));
    colorFields.put("g", new Integer(Property.NUMBER));
    colorFields.put("b", new Integer(Property.NUMBER));
    colorFields.put("a", new Integer(Property.NUMBER));
    Property.COLOR = PropertyType.addCompoundType("Color", Color.cyan, colorFieldOrder, colorFields, (new ColorProp()).getClass());

    Property.CUSTOM = PropertyType.addType("Custom", Color.white, (new CustomProp()).getClass());
  }
}